package Common;

use strict;
use warnings;

use Time::Local;

sub strip_crlf
{
	my ($str) = @_;

	$str =~ s/\r//gx;
	$str =~ s/\n//gx;

	return $str;
}

sub copyHashRef
{
	my ($in_ref) = @_;

	my $out_ref = {};

	foreach my $key (keys %$in_ref)
	{
		$out_ref->{$key} = $in_ref->{$key};
	}

	return $out_ref;
}


sub getTS
{
	my ($xtime) = @_;

	my $ctime = time ();
	if (defined $xtime) { $ctime = $xtime; }

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
 		localtime($ctime);

	$mon ++;
	$year += 1900;

	my $id = sprintf ("%4d%02d%02d%02d%02d%02d", $year, $mon, $mday, $hour, $min,
	$sec);

	return $id;
}

sub ltrim
{
	my ($string) = @_;

	$string =~ s/^\s+//;

	return $string;
}

sub rtrim
{
	my ($string) = @_;

	$string =~ s/\s+$//;

	return $string;
}

sub trim
{
	my ($string) = @_;

	$string = ltrim (rtrim ($string));

	return $string;
}

sub absval
{
	my ($val) = @_;

	if ($val < 0) { $val *= -1; }

	return $val;
}

1;

__END__

