package TimeFrame::Daily;

use strict;
use warnings;

use parent 'TimeFrame';

use Common;
use Period;

sub new
{
	my ($class) = @_;

	my $self = {};

	bless $self, $class;

	$self->SUPER::initialize ();
	$self->initialize ();

	return $self;
}

sub initialize
{
	my ($self) = @_;

	$self->{'name'} = "Daily";

	return $self;
}

sub calc_currentTimeFrame
{
	my ($self, $minute_timeframe) = @_;

	my $ref = Period::parseDateToRef ($minute_timeframe);

	my $output_timeframe = $ref->{'year'} . "-" . $ref->{'mon'} . "-" . $ref->{'mday'} . " 00:00:00";

	return $output_timeframe;
}

sub calc_nextTimeFrame
{
	my ($self, $current_timeframe) = @_;

	my $time = Period::getTimeFromDate ($current_timeframe);
	my $ywday;
	($time, $ywday) = Period::findMidnightPlusOne ($time);

	$time += (86400 + 10800);

	($time, $ywday) = Period::findMidnightPlusOne ($time);
	$time--;
	my $next_timeframe = Period::convertTimeToDate ($time);

	return $next_timeframe;
}

1;

__END__

