package TimeFrame::Hourly;

use strict;
use warnings;

use parent 'TimeFrame';

use Common;
use Period;

sub new
{
	my ($class) = @_;

	my $self = {};

	bless $self, $class;

	$self->SUPER::initialize ();
	$self->initialize ();

	return $self;
}

sub initialize
{
	my ($self) = @_;

	$self->{'name'} = "Hourly";

	return $self;
}

sub calc_currentTimeFrame
{
	my ($self, $minute_timeframe) = @_;

	my $ref = Period::parseDateToRef ($minute_timeframe);

	my $output_timeframe = $ref->{'year'} . "-" . $ref->{'mon'} . "-" . $ref->{'mday'} .
		" " . $ref->{'hour'} . ":00:00";

	return $output_timeframe;
}

sub calc_nextTimeFrame
{
	my ($self, $current_timeframe) = @_;

	my $ref = Period::parseDateToRef ($current_timeframe);

	my $xhour = $ref->{'hour'};

	if (substr ($xhour, 0, 1) eq "0")
	{
		$xhour = substr ($xhour, 1, 1);
	}

	$xhour ++;

	my $next_timeframe;

	if ($xhour >= 24)
	{
		my $time = Period::getTimeFromDate ($current_timeframe);

		$time += 3600;

		$next_timeframe = Period::convertTimeToDate ($time);
	}
	else
	{
		$xhour = "0" . $xhour if length ($xhour) == 1;

		$next_timeframe = $ref->{'year'} . "-" . $ref->{'mon'} . "-" . $ref->{'mday'} .
			" " . $xhour . ":00:00";
	}

	return $next_timeframe;
}

1;

__END__

