package TimeFrame::Minute;

use strict;
use warnings;

use parent 'TimeFrame';

use Common;
use Period;

sub new
{
	my ($class) = @_;

	my $self = {};

	bless $self, $class;

	$self->SUPER::initialize ();
	$self->initialize ();

	return $self;
}

sub initialize
{
	my ($self) = @_;

	$self->{'name'} = "Minute";

	return $self;
}

sub calc_currentTimeFrame
{
	my ($self, $minute_timeframe) = @_;

	return $minute_timeframe;
}

sub calc_nextTimeFrame
{
	my ($self, $current_timeframe) = @_;

	my $current_time = Period::getEpochFromEastern ($current_timeframe);
	my $next_time = $current_time + 60;

	my $next_timeframe = Period::getETSNormalDateForm ($next_time);

	return $next_timeframe;
}

1;

__END__

