package TimeFrame::Monthly;

use strict;
use warnings;

use parent 'TimeFrame';

use Common;
use Period;

sub new
{
	my ($class) = @_;

	my $self = {};

	bless $self, $class;

	$self->SUPER::initialize ();
	$self->initialize ();

	return $self;
}

sub initialize
{
	my ($self) = @_;

	$self->{'name'} = "Monthly";

	return $self;
}

sub calc_currentTimeFrame
{
	my ($self, $minute_timeframe) = @_;

	my $ref = Period::parseDateToRef ($minute_timeframe);

	my $output_timeframe = $ref->{'year'} . "-" . $ref->{'mon'} . "-" . "01 00:00:00";

	return $output_timeframe;
}

sub calc_nextTimeFrame
{
	my ($self, $current_timeframe) = @_;

	my $ref = Period::parseDateToRef ($current_timeframe);

	if ($ref->{'mon'} eq "12")
	{
		$ref->{'mon'} = "01";
		$ref->{'year'} ++;
	}
	else
	{
		$ref->{'mon'} ++;
	}

	my $next_timeframe = $ref->{'year'} . "-" . $ref->{'mon'} . "-" . "01 00:00:00";

	return $next_timeframe;
}

1;

__END__

