package TimeFrame::T720;

use strict;
use warnings;

use parent 'TimeFrame';

use Common;
use Period;

my @hours = ('00', '12', '24');

sub new
{
	my ($class) = @_;

	my $self = {};

	bless $self, $class;

	$self->SUPER::initialize ();
	$self->initialize ();

	return $self;
}

sub initialize
{
	my ($self) = @_;

	$self->{'name'} = "T720";

	return $self;
}

sub calc_currentTimeFrame
{
	my ($self, $minute_timeframe) = @_;

	my $ref = Period::parseDateToRef ($minute_timeframe);

	my $idx;
	my $len = @hours;

	my $xhour = $ref->{'hour'};

	for ($idx = 0; $idx < $len; ++$idx)
	{
		my $chour = $hours [$idx];
		
		die "Problem - 24" if $chour eq "24";

		my $nhour = $hours [$idx + 1];

		if ($xhour ge $chour && $xhour lt $nhour)
		{
			$xhour = $chour;
			last;
		}
	}

	my $output_timeframe = $ref->{'year'} . "-" . $ref->{'mon'} . "-" . $ref->{'mday'} .
		" " . $xhour . ":00:00";

	return $output_timeframe;
}

sub calc_nextTimeFrame
{
	my ($self, $current_timeframe) = @_;

	my $ref = Period::parseDateToRef ($current_timeframe);

	my $idx;
	my $len = @hours;

	my $xhour = $ref->{'hour'};

	for ($idx = 0; $idx < $len; ++$idx)
	{
		my $chour = $hours [$idx];
		if ($xhour eq $chour)
		{
			$xhour = $hours [$idx + 1];
			last;
		}
	}
	
	my $next_timeframe;

	if ($xhour eq "24")
	{
		my $time = Period::getTimeFromDate ($current_timeframe);
		$time += (720 * 60);

		$next_timeframe = Period::convertTimeToDate ($time);
	}
	else
	{
		$next_timeframe = $ref->{'year'} . "-" . $ref->{'mon'} . "-" . $ref->{'mday'} .
			" " . $xhour . ":00:00";
	}

	return $next_timeframe;
}

1;

__END__

