#!/usr/bin/perl

package bin::progra_001;

use strict;
use warnings;

use Common;
use Period;

use Cwd;
use Carp;
use Data::Dumper;

$| = 1;

sub myLog
{
	my ($msg) = @_;

	print $msg . "\n";
}

$SIG{__WARN__} = sub {
	my ($sig) = @_;

	myLog ("WARN :$sig:");
	myLog (Carp->longmess);
	exit 0;
};

$SIG{__DIE__} = sub {
	my ($sig) = @_;

	myLog ("DIE:$sig:");
	myLog (Carp->longmess);
	exit 0;
};

$SIG{TERM} = sub {
	my ($sig) = @_;

	print "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n";
	exit 0;
};

$SIG{INT} = sub {
	my ($sig) = @_;

	print "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n";
	exit 0;
};

sub usage
{
	my ($msg) = @_;

	print "Error: $msg\n";
	print "usage: program_002.pl YYYY-MM-DD\n";

	exit 0;
}

exit (script (@ARGV)) unless caller ();

sub script
{
	my (@args) = @_;

	my $date;
	$date = $args[0] if (@args > 0);

	usage ("Date invalid") if (!defined $date || !($date =~ m/\d\d\d\d-\d\d-\d\d/));

	my $full_date = $date . " 00:00:00";
	my $xtime = Period::getTimeFromDate ($full_date);

	for (my $i = 0; $i < 200; $i++)
	{
		my $ytime = $xtime;
		$ytime += ($i * 60);

		my $ts = Period::convertTimeToDate ($ytime);

		print $ts . "\n";
	}

	return 0;
}

1;

__END__

